###########################################################################
# Codes in this file are adapted from OneMap Package.                     #
#                                                                         #
# Copyright of the original code is detailed before each function.        #
#                                                                         #
# Contains: rf.graph.table.adpt1, parents.map.adpt, get.2pts.analysis,    #
#           rebuild.2pts.rf.obj, rebuild.outcross.obj, rebuild.LGs.obj,   #
#           order.seq.adpt, codif.data.adpt, and ripple.seq.adpt.         #
#                                                                         #
#                                                                         #
###########################################################################

############################################################################
# JMP acknowledges the use of the following Third Party software:          #
#                                                                          #
# OneMap: software for genetic mapping in outcrossing species              #
# Copyright (C) 2007-13 Gabriel R A Margarido (mmollina@usp.br) and        #
# Marcelo Mollinari (gramarga@gmail.com).                                  #
#                                                                          #
# OneMap is free software; you can redistribute it and/or modify           #
# it under the terms of the GNU General Public License as published by     #
# the Free Software Foundation; either version 2 of the License, or        #
# (at your option) any later version.                                      #
#                                                                          #
# OneMap is distributed in the hope that it will be useful,                #
# but WITHOUT ANY WARRANTY; without even the implied warranty of           #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            #
# GNU General Public License for more details.                             #
#                                                                          #
# You should have received a copy of the GNU General Public License        # 
# along with this program; if not, write to the Free Software              # 
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,# 
# USA."                                                                    #  
############################################################################        

#######################################################################
#                                                                     #
# Function: rf.graph.table.adpt1                                      #
#                                                                     #
# Adapted from rf_graph_table (found in the R package onemap)         #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2009, Marcelo Mollinari                               #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################
rf.graph.table.adpt1 <- function (input.seq) 
{

    #### Prior to OneMap version 2.1.1  ####
    #if (!any(class(input.seq) == "sequence")) 
    #    stop(deparse(substitute(input.seq)), " is not an object of class 'sequence'")
    #if (input.seq$seq.phases[1] == -1 || input.seq$seq.rf[1] == 
    #    -1 || is.null(input.seq$seq.like)) 
    #    stop("You must estimate parameters before running 'rf.graph.table' ")
    #size <- length(input.seq$seq.num)
    #max.rf <- 0.5
    #LOD <- list(CC = matrix(NA, size, size), CR = matrix(NA, 
    #    size, size), RC = matrix(NA, size, size), RR = matrix(NA, 
    #    size, size))
    #mat <- matrix(0, size, size)
    #mat.rf <- matrix(0, size, size)
    #for (i in 2:size) {
    #    for (j in 1:(i - 1)) {
    #        big <- pmax.int(input.seq$seq.num[i], input.seq$seq.num[j])
    #        small <- pmin.int(input.seq$seq.num[i], input.seq$seq.num[j])
    #        current <- get(input.seq$twopt, pos = 1)$analysis[acum(big - 2) + small, , ]
    #        probab <- which(current[, 2] > (max(current[, 2] - 0.005)) & current[, 2] <= max(current[, 2]))
    #        goodness <- numeric(4)
    #        for (a in probab) {
    #            if (current[a, 1] <= max.rf) 
    #              goodness[a] <- 1
    #            else goodness[a] <- 0
    #        }
    #        goodness[-probab] <- 0
    #        phase <- which(goodness == 1)
    #        if (length(phase) == 0) {
    #            mat[j, i] <- 0
    #            mat.rf[j, i] <- mat.rf[i, j] <- mat[i, j] <- 0.5
    #        }
    #        else {
    #            mat[j, i] <- max(current[phase, 2])
    #            mat.rf[j, i] <- mat.rf[i, j] <- mat[i, j] <- min(current[phase,1])
    #        }
    #        LOD$CC[i, j] <- LOD$CC[j, i] <- current[1, 2]
    #        LOD$CR[i, j] <- LOD$CR[j, i] <- current[2, 2]
    #        LOD$RC[i, j] <- LOD$RC[j, i] <- current[3, 2]
    #        LOD$RR[i, j] <- LOD$RR[j, i] <- current[4, 2]
    #    }
    #}
    #mat[row(mat) > col(mat) & mat > 0.5] <- 0.5
    #mat[row(mat) < col(mat)][mat[row(mat) < col(mat)] < 0.1] <- 0.1
    #log.LOD <- log(mat[row(mat) < col(mat)]) + abs(min(log(mat[row(mat) < 
    #    col(mat)]), na.rm = TRUE))
    #mat[row(mat) < col(mat)] <- 0.5 - log.LOD/(2 * max(log.LOD, 
    #    na.rm = TRUE))
    #diag(mat) <- NA
    #for (i in 1:(size - 1)) {
    #    mat[i + 1, i] <- input.seq$seq.rf[i]
    #    mat.rf[i + 1, i] <- mat.rf[i, i + 1] <- input.seq$seq.rf[i]
    #}
    #colnames(mat) <- get(input.seq$twopt, pos = 1)$marnames[input.seq$seq.num]
    #types <- get(input.seq$data.name, pos = 1)$segr.type[input.seq$seq.num]
    #which.D1D2 <- outer((substr(types, 1, 2) == "D1"), (substr(types, 
    #    1, 2) == "D2"))
    #which.D1D2 <- which.D1D2 + t(which.D1D2)
    #which.D1D2[which.D1D2 == 1] <- NA
    #which.D1D2[which.D1D2 == 0] <- 1
    #diag.si <- rbind(1:(ncol(which.D1D2) - 1), 2:ncol(which.D1D2))
    #for (i in 1:(ncol(which.D1D2) - 1)) which.D1D2[diag.si[1, 
    #    i], diag.si[2, i]] <- which.D1D2[diag.si[2, i], diag.si[1, 
    #    i]] <- 1
    #mat <- mat * which.D1D2
    #missing <- 100 * apply(get(input.seq$data.name, pos = 1)$geno[, 
    #    input.seq$seq.num], 2, function(x) sum(x == 0))/get(input.seq$data.name, 
    #    pos = 1)$n.ind
    #info.graph <- list(mat = mat, mat.rf = mat.rf, seq.num = input.seq$seq.num, 
    #    n = ncol(mat), names = colnames(mat), types = types, 
    #    LOD = LOD, missing = missing, data.name = input.seq$data.name)   
    #info.graph
    ############################################################################
    
    
    #### OneMap version 2.1.1 #### 
    ## checking for correct objects
    if(!any(class(input.seq)=="sequence"))
        stop(deparse(substitute(input.seq))," is not an object of class 'sequence'")

    if(is(get(input.seq$data.name), "outcross"))
    {
        if(input.seq$seq.phases[1] == -1 || input.seq$seq.rf[1] == -1 || is.null(input.seq$seq.like))
            stop("You must estimate parameters before running 'rf_graph_table' ")
        ## making a list with necessary information
        n.mrk <- length(input.seq$seq.num)
        LOD <- lapply(get(input.seq$twopt)$analysis,
                      function(x, w){
                          m<-matrix(0, length(w), length(w))
                          for(i in 1:(length(w)-1)){
                              for(j in (i+1):length(w)){
                                  z<-sort(c(w[i],w[j]))
                                  m[j,i]<-m[i,j]<-x[z[1], z[2]]
                              }
                          }
                          return(m)
                      }, input.seq$seq.num
                      )
        mat<-t(get_mat_rf_out(input.seq, LOD=TRUE,  max.rf = 0.501, min.LOD = -0.1))
        mat.rf<-t(get_mat_rf_out(input.seq, LOD=FALSE,  max.rf = 0.501, min.LOD = -0.1))
    }
    else
    {
        if(input.seq$seq.rf[1] == -1 || is.null(input.seq$seq.like))
            stop("You must estimate parameters before running 'rf_graph_table' ")
        ## making a list with necessary information
        n.mrk <- length(input.seq$seq.num)

        LOD<-matrix(0, length(input.seq$seq.num), length(input.seq$seq.num))
        for(i in 1:(length(input.seq$seq.num)-1)){
            for(j in (i+1):length(input.seq$seq.num)){
                z<-sort(c(input.seq$seq.num[i],input.seq$seq.num[j]))
                LOD[j,i]<-LOD[i,j]<-get(input.seq$twopt)$analysis[z[1], z[2]]
            }
        }
        mat<-t(get_mat_rf_in(input.seq, LOD=TRUE,  max.rf = 0.501, min.LOD = -0.1))
        mat.rf<-t(get_mat_rf_in(input.seq, LOD=FALSE,  max.rf = 0.501, min.LOD = -0.1))
    }

    ##Scaling the LODs to print them properly
    range.LOD<-range(as.dist(t(mat)), na.rm=TRUE)
    range.rf<-range(as.dist(mat), na.rm=TRUE)
    mat[row(mat) > col(mat) & mat > 0.5] <- 0.5 ## if there are recombinations greater than 0.5 (for numrical convergence problems), assuming 0.5
    mat[row(mat) < col(mat)][mat[row(mat) < col(mat)] < 10E-2]<-10E-2
    min.scale<-abs(min(log(mat[row(mat) < col(mat)]), na.rm=TRUE))
    log.LOD<-log(mat[row(mat) < col(mat)]) + min.scale
    max.scale<-2*max(log.LOD, na.rm=TRUE)
    mat[row(mat) < col(mat)] <- 0.5 - log.LOD/max.scale
    diag(mat)<-NA
    range.scaled.LOD<-range(as.dist(t(mat)), na.rm=TRUE)

    ##Write multipoint estimates
    for (i in 1:(n.mrk-1)){
        mat[i+1,i] <- input.seq$seq.rf[i]
        mat.rf[i+1,i] <- mat.rf[i,i+1] <- input.seq$seq.rf[i]
    }
    colnames(mat) <- colnames(get(input.seq$data.name, pos=1)$geno)[input.seq$seq.num]

    ##Write NAs in two-point recombination fractions between markers of type D1 and D2
    types <- get(input.seq$data.name, pos=1)$segr.type[input.seq$seq.num]
    which.D1D2<-outer((substr(types, 1,2)=="D1"),(substr(types, 1,2)=="D2"))
    which.D1D2<-which.D1D2+t(which.D1D2)
    which.D1D2[which.D1D2==1]<-NA
    which.D1D2[which.D1D2==0]<-1
    diag.si<-rbind(1:(ncol(which.D1D2)-1),2:ncol(which.D1D2))
    for(i in 1:(ncol(which.D1D2)-1)) which.D1D2[diag.si[1,i],diag.si[2,i]] <- which.D1D2[diag.si[2,i],diag.si[1,i]] <- 1
    mat<-mat*which.D1D2
    missing<-100*apply(get(input.seq$data.name, pos=1)$geno[,input.seq$seq.num],2, function(x) sum(x==0))/get(input.seq$data.name, pos=1)$n.ind

    ##info.graph contains all information necessary to plot the graphics
    info.graph <- list(mat=mat,
                       mat.rf=mat.rf,
                       seq.num=input.seq$seq.num,
                       n=ncol(mat),
                       names=colnames(mat),
                       types=types,
                       LOD=LOD,
                       min.scale=min.scale,
                       max.scale=max.scale,
                       range.rf=range.rf,
                       range.LOD=range.LOD,
                       range.scaled.LOD=range.scaled.LOD,
                       missing=missing,
                       data.name=input.seq$data.name
                       #,mrk.names=mrk.names,
                       #colorkey=colorkey
                       )
	info.graph
}

#######################################################################
#                                                                     #
# Function: parents.map.adpt                                          #
#                                                                     #
# Adapted from print.sequence (found in the R package onemap)         #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2009, Gabriel R A Margarido                           #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################
parents.map.adpt <- function(x) {
        link.phases <- matrix(NA, length(x$seq.num), 2)
        link.phases[1, ] <- rep(1, 2)
        for (i in 1:length(x$seq.phases)) {
            switch(EXPR = x$seq.phases[i], 
                link.phases[i + 1,] <- link.phases[i, ] * c(1, 1), 
                link.phases[i + 1, ] <- link.phases[i, ] * c(1, -1), 
                link.phases[i + 1, ] <- link.phases[i, ] * c(-1, 1), 
                link.phases[i + 1, ] <- link.phases[i, ] * c(-1, -1), 
                )
        }
            link.phases <- apply(link.phases, 1, function(x) paste(as.character(x), 
                collapse = "."))
            parents <- matrix("", length(x$seq.num), 4)
            for (i in 1:length(x$seq.num)) parents[i, ] <- return_geno(get(x$data.name, 
                pos = 1)$segr.type[x$seq.num[i]], link.phases[i])
    
    parents
}

#######################################################################
#                                                                     #
# Function: get.2pts.analysis                                         #
#                                                                     #
# Adapted from rf_2pts (found in the R package onemap)                #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2007-9, Gabriel R A Margarido                         #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################
get.2pts.analysis <- function (input.obj) {
        if (!any(class(input.obj) == "rf_2pts")) 
        stop(deparse(substitute(input.obj)), " is not an object of class 'rf_2pts'")

        best.rf.mat <- best.lod.mat <- best.ph.mat <- matrix(0, nrow=input.obj$n.mar, ncol=input.obj$n.mar)
        colnames(best.rf.mat) <- paste("col", seq(1:input.obj$n.mar),sep="")
        colnames(best.lod.mat) <- paste("lcol", seq(1:input.obj$n.mar),sep="")
        colnames(best.ph.mat) <- paste("pcol", seq(1:input.obj$n.mar),sep="")
	#### Prior to OneMap version 2.1.1  ####
        #best.rf.vec <- apply(input.obj$analysis[,,1],1,min)
        #best.lod.vec <- apply(input.obj$analysis[,,2],1,max)        
        #best.ph.vec <- apply(input.obj$analysis[,,2],1,which.max)
        #all.phases <- matrix(NA, nrow= (input.obj$n.mar/2)*(input.obj$n.mar - 1), ncol=2)
        #all.phases <- cbind(all.phases, input.obj$analysis[,1,1],
        #                                input.obj$analysis[,2,1],
        #                                input.obj$analysis[,3,1],
        #                                input.obj$analysis[,4,1],
        #                                input.obj$analysis[,1,2],
        #                                input.obj$analysis[,2,2],
        #                                input.obj$analysis[,3,2],
        #                                input.obj$analysis[,4,2]
        #                                )
        ##########################################################
        
        #### OneMap version 2.1.1 ####
        #print(input.obj$analysis)
        
        analysis_tmp <- array(NA, dim=c(input.obj$n.mar/2 * (input.obj$n.mar - 1), 4, 2))
        cc.rf <- t(input.obj$analysis$CC)[t(lower.tri(input.obj$analysis$CC))]
        cr.rf <- t(input.obj$analysis$CR)[t(lower.tri(input.obj$analysis$CR))]
        rc.rf <- t(input.obj$analysis$RC)[t(lower.tri(input.obj$analysis$RC))]
        rr.rf <- t(input.obj$analysis$RR)[t(lower.tri(input.obj$analysis$RR))]

	analysis_tmp[,1,1] <- cc.rf
	analysis_tmp[,2,1] <- cr.rf
	analysis_tmp[,3,1] <- rc.rf
	analysis_tmp[,4,1] <- rr.rf

        cc.lod <- t(input.obj$analysis$CC)[t(upper.tri(input.obj$analysis$CC))]
        cr.lod <- t(input.obj$analysis$CR)[t(upper.tri(input.obj$analysis$CR))]
        rc.lod <- t(input.obj$analysis$RC)[t(upper.tri(input.obj$analysis$RC))]
        rr.lod <- t(input.obj$analysis$RR)[t(upper.tri(input.obj$analysis$RR))]

	analysis_tmp[,1,2] <- cc.lod
	analysis_tmp[,2,2] <- cr.lod
	analysis_tmp[,3,2] <- rc.lod
	analysis_tmp[,4,2] <- rr.lod 
	
	#print(analysis_tmp[,,1])
        
        best.rf.vec <- apply(analysis_tmp[,,1],1,min)
        best.lod.vec <- apply(analysis_tmp[,,2],1,max)        
        best.ph.vec <- apply(analysis_tmp[,,2],1,which.max)                
        all.phases <- matrix(NA, nrow= (input.obj$n.mar/2)*(input.obj$n.mar - 1), ncol=2)
        all.phases <- cbind(all.phases, analysis_tmp[,1,1],
                                        analysis_tmp[,2,1],
                                        analysis_tmp[,3,1],
                                        analysis_tmp[,4,1],
                                        analysis_tmp[,1,2],
                                        analysis_tmp[,2,2],
                                        analysis_tmp[,3,2],
                                        analysis_tmp[,4,2]
                                        )        
        ##########################################################
        

        k <- 1
        for (i in 2:input.obj$n.mar) {
            for (j in 1:(i - 1)) {
                if ((get(input.obj$data.name)$segr.type.num[i] == 6 && get(input.obj$data.name)$segr.type.num[j] == 7) ||
                    (get(input.obj$data.name)$segr.type.num[i] == 7 && get(input.obj$data.name)$segr.type.num[j] == 6)) {
                    best.rf.mat[i,j] <- best.rf.mat[j,i] <- NA
                    best.lod.mat[i,j] <- best.lod.mat[j,i] <- NA
                    best.ph.mat[i,j] <- best.ph.mat[i,j] <- NA                    
                    all.phases[k,3:dim(all.phases)[2]] <- NA
                }
                else {
                    best.rf.mat[i,j] <- best.rf.mat[j,i] <- best.rf.vec[acum(i - 2) + j]
                    best.lod.mat[i,j] <- best.lod.mat[j,i] <- best.lod.vec[acum(i - 2) + j]
                    best.ph.mat[i,j] <- best.ph.mat[j,i] <- best.ph.vec[acum(i - 2) + j]
                }
                #### Prior to OneMap version 2.1.1  ####
                #all.phases[k,1:2] <- c(input.obj$marnames[j], input.obj$marnames[i])
                #####################################################################
                
                #### OneMap version 2.1.1 ####   
		all.phases[k,1:2] <- c(colnames((get(input.obj$data.name)$geno))[j],colnames((get(input.obj$data.name)$geno))[i])
                ######################################################################
                
                k <- k + 1
            }
        }
        
        colnames(all.phases) <- c("Marker1","Marker2",
                                        "rf1","rf2","rf3","rf4",
                                        "lod1","lod2","lod3","lod4")

        structure(list(best.rf2.pts.mat=best.rf.mat,
                        best.lod2.pts.mat=best.lod.mat,
                        best.ph2.pts.mat=best.ph.mat,
                        all.phases=all.phases 
                        )
                )
}

#######################################################################
#                                                                     #
# Function: rebuild.2pts.rf.obj                                       #
#                                                                     #
# Adapted from rf_2pts (found in the R package onemap)                #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2007-9, Gabriel R A Margarido                         #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################
rebuild.2pts.rf.obj <- function(phasesdata, outcrossobj, minLOD, maxRF) {
        # I assume that phasesdata was formed by stacking rows of the lower diagonal #
        # matrix without the diagonal elements (row-wise stacking).                  #
        
        #print(phasesdata)

	#### Prior to OneMap version 2.1.1  ####
        #if (!any(class(outcrossobj) == "outcross")) 
        #stop(deparse(substitute(outcrossobj)), " is not an object of class 'outcross'")
      
        #phnames <- toupper(colnames(phasesdata)) 
        #rfcol <- pmatch(c("RF1", "RF2", "RF3", "RF4"), phnames)
        #lodcol <- pmatch(c("LOD1", "LOD2", "LOD3", "LOD4"), phnames)
        #analysis <- array(NA, dim=c(outcrossobj$n.mar/2 * (outcrossobj$n.mar - 1), 4, 2))
        #phasesdata <- as.matrix(phasesdata)
        #k <- 1
        #for (i in 2:outcrossobj$n.mar) {
        #    for (j in 1:(i - 1)) {
        #        if ((outcrossobj$segr.type.num[i] == 6 && outcrossobj$segr.type.num[j] == 7) ||
        #            (outcrossobj$segr.type.num[i] == 7 && outcrossobj$segr.type.num[j] == 6)) {
        #            analysis[k,,1] <- rep(0.25, 4)
        #            analysis[k,,2] <- rep(0.00, 4)
        #        }
        #        else {
        #            analysis[k,,1] <- as.numeric(phasesdata[k,rfcol])
        #            analysis[k,,2] <- as.numeric(phasesdata[k,lodcol])
        #        }
        #        k <- k + 1
        #    }
        #}
        
        #dimnames(analysis) <- list(NULL, c("1", "2", "3", "4"), c("Theta", "LODs"))

        #structure(list(data.name= deparse(substitute(outcrossobj)),
        #                n.mar= outcrossobj$n.mar,    
        #                marnames= colnames(outcrossobj$geno),  
        #                LOD= minLOD,       
        #                max.rf= maxRF,
        #                input= outcrossobj$input,
        #                analysis= analysis),
        #                class= "rf_2pts"
        #                )
        #####################################################
        
        #### OneMap version 2.1.1 ####   
        if (!any(class(outcrossobj) == "outcross")) 
        stop(deparse(substitute(outcrossobj)), " is not an object of class 'outcross'")
      
        phnames <- toupper(colnames(phasesdata)) 
        rfcol <- pmatch(c("RF1", "RF2", "RF3", "RF4"), phnames)
        lodcol <- pmatch(c("LOD1", "LOD2", "LOD3", "LOD4"), phnames)
        analysis_tmp <- array(NA, dim=c(outcrossobj$n.mar/2 * (outcrossobj$n.mar - 1), 4, 2))
        phasesdata <- as.matrix(phasesdata)
        k <- 1
        for (i in 2:outcrossobj$n.mar) {
            for (j in 1:(i - 1)) {
                if ((outcrossobj$segr.type.num[i] == 6 && outcrossobj$segr.type.num[j] == 7) ||
                    (outcrossobj$segr.type.num[i] == 7 && outcrossobj$segr.type.num[j] == 6)) {
                    analysis_tmp[k,,1] <- rep(0.25, 4)
                    analysis_tmp[k,,2] <- rep(0.00, 4)
                }
                else {
                    analysis_tmp[k,,1] <- as.numeric(phasesdata[k,rfcol])
                    analysis_tmp[k,,2] <- as.numeric(phasesdata[k,lodcol])
                }
                k <- k + 1
            }
        }   
        
	rf.lod.cc <- matrix(0, nrow=outcrossobj$n.mar, ncol=outcrossobj$n.mar)
	rf.lod.cc[t(lower.tri(rf.lod.cc))] <- analysis_tmp[,1,1]
	rf.lod.cc[t(upper.tri(rf.lod.cc))] <- analysis_tmp[,1,2]
	rf.lod.cc<-t(rf.lod.cc)
        
	rf.lod.cr <- matrix(0, nrow=outcrossobj$n.mar, ncol=outcrossobj$n.mar)
	rf.lod.cr[t(lower.tri(rf.lod.cr))] <- analysis_tmp[,2,1]
	rf.lod.cr[t(upper.tri(rf.lod.cr))] <- analysis_tmp[,2,2]
	rf.lod.cr<-t(rf.lod.cr)
	
	rf.lod.rc <- matrix(0, nrow=outcrossobj$n.mar, ncol=outcrossobj$n.mar)
	rf.lod.rc[t(lower.tri(rf.lod.rc))] <- analysis_tmp[,3,1]
	rf.lod.rc[t(upper.tri(rf.lod.rc))] <- analysis_tmp[,3,2]
	rf.lod.rc<-t(rf.lod.rc)	
	
	rf.lod.rr <- matrix(0, nrow=outcrossobj$n.mar, ncol=outcrossobj$n.mar)
	rf.lod.rr[t(lower.tri(rf.lod.rr))] <- analysis_tmp[,4,1]
	rf.lod.rr[t(upper.tri(rf.lod.rr))] <- analysis_tmp[,4,2]
	rf.lod.rr<-t(rf.lod.rr)	
	
	mrknames <- colnames(outcrossobj$geno)
	
	colnames(rf.lod.cc) <- rownames(rf.lod.cc) <- mrknames
	colnames(rf.lod.cr) <- rownames(rf.lod.cr) <- mrknames
	colnames(rf.lod.rc) <- rownames(rf.lod.rc) <- mrknames
	colnames(rf.lod.rr) <- rownames(rf.lod.rr) <- mrknames
        
        structure(list(data.name= deparse(substitute(outcrossobj)),
                        n.mar= outcrossobj$n.mar,     
                        LOD= minLOD,       
                        max.rf= maxRF,
                        input= outcrossobj$input,
                        CHROM= NULL,
                        POS= NULL,
                        analysis= structure(list(CC= rf.lod.cc, CR= rf.lod.cr, RC= rf.lod.rc, RR= rf.lod.rr))),
                        class= c("rf_2pts", class(outcrossobj)[2])
                 )
                        
}

###################################################################################
#                                                                                 #
# Function: rebuild.outcross.obj                                                  #
#                                                                                 #
# Adapted from both read_onemap and codif.data (found in the R package onemap)  #
# Written by Luciano da Costa e Silva                                             #
# codif.data(): copyright (c) 2009, Marcelo Mollinari                             #
# read.outcross(): copyright (c) 2000-6, Karl W Broman                            #
#                                                                                 #
# First version: Nov 2013                                                         #
# Last update: Nov 2013                                                           #
# License: GNU General Public License version 2 (June, 1991) or later             #
#                                                                                 #
###################################################################################
rebuild.outcross.obj <- function(genodata, annodata, mktype) {
## Since this function is being used just to create an outcross object with   ##
## genotypes for afterwards estimation of linkage groups and conditional      ##
## probabilities of pseudomarkers, there is no need to include the phenotypic ##
## data of traits into the outcross object.                                   ##
        
        #print("genodata")
        #print(genodata)
        #print(annodata)
        #print(mktype)
                
        n.mrk.geno <- dim(genodata)[2]
        n.ind.geno <- dim(genodata)[1]
        #n.mrk.anno <- dim(annodata)[1]
                
        #if(n.mrk.geno != n.mrk.anno)
        #       stop("InData and Annotation do not have equal number of markers.", call.=FALSE)
                                
        geno <- matrix(NA, nrow= n.ind.geno, ncol=n.mrk.geno)
        #print(which(pmatch(as.matrix(genodata), NA, duplicates.ok=TRUE)==1))
        #geno[which(pmatch(as.matrix(genodata), NA, duplicates.ok=TRUE)==1)] <- 0
        colnames(geno) <- colnames(genodata)
        segr.type.num <- rep(NA, n.mrk.geno)
        segr.type <- rep(NA, n.mrk.geno)
        
        mktype_num <- pmatch(toupper(mktype), toupper(colnames(annodata)))
        
        for(i in 1:n.mrk.geno){ 
                         #print(genodata[, i])  
                         switch(EXPR = as.character(annodata[i, mktype_num]), 
                                A.1 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "ac"), i] <- 1
                                    geno[which(genodata[, i] == "ad"), i] <- 2
                                    geno[which(genodata[, i] == "bc"), i] <- 3
                                    geno[which(genodata[, i] == "bd"), i] <- 4
                                    segr.type.num[i] <- 1
                                    segr.type[i] <- "A.1"
                                }, A.2 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0 
                                    geno[which(genodata[, i] == "a"), i] <- 1
                                    geno[which(genodata[, i] == "ac"), i] <- 2
                                    geno[which(genodata[, i] == "ba"), i] <- 3
                                    geno[which(genodata[, i] == "bc"), i] <- 4
                                    segr.type.num[i] <- 1
                                    segr.type[i] <- "A.2"
                                }, A.3 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "ac"), i] <- 1
                                    geno[which(genodata[, i] == "a"), i] <- 2
                                    geno[which(genodata[, i] == "bc"), i] <- 3
                                    geno[which(genodata[, i] == "b"), i] <- 4
                                    segr.type.num[i] <- 1
                                    segr.type[i] <- "A.3"
                                }, A.4 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "ab"), i] <- 1
                                    geno[which(genodata[, i] == "a"), i] <- 2
                                    geno[which(genodata[, i] == "b"), i] <- 3
                                    geno[which(genodata[, i] == "o"), i] <- 4
                                    segr.type.num[i] <- 1
                                    segr.type[i] <- "A.4"
                                }, B1.5 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "a"), i] <- 1
                                    geno[which(genodata[, i] == "ab"), i] <- 2
                                    geno[which(genodata[, i] == "b"), i] <- 3
                                    segr.type.num[i] <- 2
                                    segr.type[i] <- "B1.5"
                                }, B2.6 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "a"), i] <- 1
                                    geno[which(genodata[, i] == "ab"), i] <- 2
                                    geno[which(genodata[, i] == "b"), i] <- 3
                                    segr.type.num[i] <- 3
                                    segr.type[i] <- "B2.6"
                                }, B3.7 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "a"), i] <- 1
                                    geno[which(genodata[, i] == "ab"), i] <- 2
                                    geno[which(genodata[, i] == "b"), i] <- 3
                                    segr.type.num[i] <- 4
                                    segr.type[i] <- "B3.7"
                                }, C.8 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "a"), i] <- 1
                                    geno[which(genodata[, i] == "o"), i] <- 2
                                    segr.type.num[i] <- 5
                                    segr.type[i] <- "C.8"
                                }, D1.9 = {
                                    geno[which(is.na(genodata[, i])), i] <- 0
                                    geno[which(genodata[, i] == "ac"), i] <- 1
                                    geno[which(genodata[, i] == "bc"), i] <- 2
                                    segr.type.num[i] <- 6
                                    segr.type[i] <- "D1.9"
                                }, D1.10 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "a"), i] <- 1
                                   geno[which(genodata[, i] == "ab"), i] <- 2
                                   segr.type.num[i] <- 6
                                   segr.type[i] <- "D1.10"
                                }, D1.11 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "a"), i] <- 1
                                   geno[which(genodata[, i] == "b"), i] <- 2
                                   segr.type.num[i] <- 6
                                   segr.type[i] <- "D1.11"
                                }, D1.12 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "ab"), i] <- 1
                                   geno[which(genodata[, i] == "a"), i] <- 2
                                   segr.type.num[i] <- 6
                                   segr.type[i] <- "D1.12"
                                }, D1.13 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "a"), i] <- 1
                                   geno[which(genodata[, i] == "o"), i] <- 2
                                   segr.type.num[i] <- 6
                                   segr.type[i] <- "D1.13"
                                }, D2.14 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "ac"), i] <- 1
                                   geno[which(genodata[, i] == "bc"), i] <- 2
                                   segr.type.num[i] <- 7
                                   segr.type[i] <- "D2.14"
                                }, D2.15 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "a"), i] <- 1
                                   geno[which(genodata[, i] == "ab"), i] <- 2
                                   segr.type.num[i] <- 7
                                   segr.type[i] <- "D2.15"
                                }, D2.16 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "a"), i] <- 1
                                   geno[which(genodata[, i] == "b"), i] <- 2
                                   segr.type.num[i] <- 7
                                   segr.type[i] <- "D2.16"
                                }, D2.17 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "ab"), i] <- 1
                                   geno[which(genodata[, i] == "a"), i] <- 2
                                   segr.type.num[i] <- 7
                                   segr.type[i] <- "D2.17"
                                }, D2.18 = {
                                   geno[which(is.na(genodata[, i])), i] <- 0
                                   geno[which(genodata[, i] == "a"), i] <- 1
                                   geno[which(genodata[, i] == "o"), i] <- 2
                                   segr.type.num[i] <- 7
                                   segr.type[i] <- "D2.18"     
                                },
                                stop(paste("Marker type ", as.character(annodata[i, mktype_num]), " does not exist!", sep=""))
                        )
                        
                        if (any(is.na(geno[,i]))) {
                                stop(paste("Genotype code ",genodata[which(is.na(geno[,i])),i]," of marker ", i, " on individuals ", which(is.na(geno[,i]))," are incorrect!", sep=""))
                        }
        }       

        indata <- vector("list", 10)
        class(indata) <- c("onemap", "outcross") 
        names(indata) <- c("geno", "n.ind", "n.mar", "segr.type", "segr.type.num", "n.phe", "pheno", "CHROM", "POS", "input")
        indata$geno <- as.matrix(geno)
        indata$n.ind <- as.integer(n.ind.geno)
        indata$n.mar <- n.mrk.geno
        indata$segr.type <- segr.type
        indata$segr.type.num <- as.vector(segr.type.num)
        indata$CHROM <- NULL
        indata$POS <- NULL
        indata$input <- NULL
        ## Function probs() from OneQTL requires that at least one trait is included into the outcross object.           ##
        ## Setting n.phe to 1 and pheno to a matrix are just tricks to make the probs() function to work without errors ##
        #indata$n.phe <- 1
        #indata$pheno <- matrix(numeric(0), 1,1)         
        indata$n.phe <- 0
        indata$pheno <- NULL   

        indata
}

#######################################################################
#                                                                     #
# Function: rebuild.LGs.obj                                           #
#                                                                     #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2013, Luciano da Costa e Silva                        #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################
rebuild.LGs.obj <- function(genodata, annodata, chrom, mkpos, mklab, linkphase, mapfunc, outcrossobjname) {
### I assume that each column marker in genodata (from left to right) is ordered on the rows of annodata (from to botton)   ###
### All markers in genodata must be in annodata and they must be in the first rows of annodata, which may have more markers ###
### than genodata.                                                                                                          ###

       # print("rebuild.LGs.obj")
       # print(genodata)
       # print(annodata)
       # print(chrom)
       # print(mkpos)
       # print(mklab)
       # print(linkphase)
       # print(mapfunc)

        n.mrk.geno <- dim(genodata)[2]  
        
        subannodata <- annodata[1:n.mrk.geno, ]
        
        chrs <- unique(subannodata[1:n.mrk.geno, chrom])

        LGs.all <- vector("list", length(chrs))

        for(i in chrs){

                which.rows <- as.vector(apply(as.matrix(subannodata[,chrom]), 2, function(x) which(x==i)))

                seq.phases.tmp <- as.vector(subannodata[which.rows, linkphase])[-1]
                
                cM.tmp <- as.vector(subannodata[which.rows, mkpos])
                
                names(cM.tmp) <- as.vector(subannodata[which.rows, mklab])

                seq.rf.tmp <- rep(NA, (length(cM.tmp) - 1))             
                for(k in 2:length(cM.tmp)){
                        x = (cM.tmp[k]-cM.tmp[k-1])/100.0 
                        if (mapfunc == "Haldane")
                                seq.rf.tmp[k-1] <- 0.5*(1.0-exp(-2.0*x))
                        else
                                seq.rf.tmp[k-1] <- (1-exp(-4*x))/(2*(1+exp(-4*x)))
                }               
                
                tmpseq <- vector("list", 6)
                class(tmpseq) <- "sequence"
                names(tmpseq) <- c("seq.num", "seq.phases", "seq.rf", "seq.like", "data.name", "twopt")
                tmpseq$seq.num <- as.vector(which.rows)
                tmpseq$seq.phases <- as.vector(seq.phases.tmp)
                tmpseq$seq.rf <- as.vector(seq.rf.tmp)
                tmpseq$seq.like <- numeric(0)
                tmpseq$data.name <- outcrossobjname
                tmpseq$twopt <- numeric(0)
                
                LGs.all[[i]] <- tmpseq
        }       
        
        LGInfo <- structure(list(LGs.map= LGs.all,
                                LGs.num = chrs))
                        
        LGInfo

}

#######################################################################
#                                                                     #
# Function: order.seq.adpt                                            #
#                                                                     #
# Adapted from order_seq (found in the R package onemap)              #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2009, Gabriel R A Margarido & Marcelo Mollinari       #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################
order.seq.adpt <- function(input.seq, n.init = 5, subset.search = c("twopt", "sample"), 
    subset.n.try = 30, subset.THRES = 3, twopt.alg = c("rec", "rcd", "ser", "ug"), 
    THRES = 3, touchdown = FALSE, draw.try = FALSE, wait = 0, tol = 0.1, framed.num= NULL) 
{
    if (!any(class(input.seq) == "sequence")) 
        stop(deparse(substitute(input.seq)), " is not an object of class 'sequence'")
    if (n.init < 2) 
        stop("'n.init' must be greater than or equal to 2")
    if (!is.logical(touchdown)) 
        stop("'touchdown' must be logical")
    if (!touchdown && THRES <= 1e-09) 
        stop("Threshold must be greater than 0 if 'touchdown' is FALSE")
    if (touchdown && THRES <= (1 + 1e-09)) 
        stop("Threshold must be greater than 1 if 'touchdown' is TRUE")
    if (wait < 0) {
        warning("'wait' shouldn't be < 0!")
        wait <- 0
    }
    if (draw.try == FALSE) 
        wait <- 0
    if (is.null(framed.num)) {
            if (length(input.seq$seq.num) <= n.init) {
                cat("   Length of sequence ", deparse(substitute(input.seq)), 
                    " is less than n.init \n   Returning the best order using compare function:\n")
                ifelse(length(input.seq$seq.num) == 2, seq.ord <- map(input.seq, 
                    tol = 1e-04), seq.ord <- make_seq(compare(input.seq = input.seq, 
                    tol = 1e-04), 1))
                seq.ord <- map(seq.ord, tol = 1e-04)
                structure(list(ord = seq.ord, mrk.unpos = NULL, LOD.unpos = NULL, 
                    THRES = THRES, ord.all = seq.ord, data.name = input.seq$data.name, 
                    twopt = input.seq$twopt), class = "order")
            }
            else {
            	cross.type <- class(get(input.seq$data.name, pos = 1))[2]
                if (cross.type == "f2") FLAG <- "f2"
                else if (cross.type == "backcross" || 
                	cross.type == "riself" || 
                	cross.type == "risib") FLAG <- "bc"
                else if (cross.type == "outcross") FLAG <- "outcross"
                else stop("Invalid cross type\n")
                if (FLAG == "bc" || FLAG == "f2") {
                    subset.search <- match.arg(subset.search)
                    if (subset.search == "twopt") {
                        cat("\nCross type: ", cross.type, "\nChoosing initial subset using 'two-point' approach\n")
                        twopt.alg <- match.arg(twopt.alg)
                        tpt.type <- switch(EXPR = twopt.alg, rec = {
                          seq.rec <- record(input.seq = input.seq, tol = 0.1)$seq.num
                          seq.init <- seq.rec[unique(round(seq(from = 1, 
                            to = length(seq.rec), length.out = n.init)))]
                        }, rcd = {
                          seq.rcd <- rcd(input.seq = input.seq, tol = 0.1)$seq.num
                          seq.init <- seq.rcd[unique(round(seq(from = 1, 
                            to = length(seq.rcd), length.out = n.init)))]
                        }, ser = {
                          seq.ser <- seriation(input.seq = input.seq, 
                            tol = 0.1)$seq.num
                          seq.init <- seq.ser[unique(round(seq(from = 1, 
                            to = length(seq.ser), length.out = n.init)))]
                        }, ug = {
                          seq.ug <- ug(input.seq = input.seq, tol = 0.1)$seq.num
                          seq.init <- seq.ug[unique(round(seq(from = 1, 
                            to = length(seq.ug), length.out = n.init)))]
                        })
                        seq.rest <- input.seq$seq.num[-pmatch(seq.init, 
                          input.seq$seq.num)]
                        seq.mis <- apply(as.matrix(get(input.seq$data.name, 
                          pos = 1)$geno[, seq.rest]), 2, function(x) sum(x == 
                          0))
                        names(seq.mis) <- colnames(get(input.seq$data.name, 
                          pos = 1)$geno)[seq.rest]
                        if (FLAG == "bc") {
                          rest.ord <- pmatch(names(seq.mis), colnames(get(input.seq$data.name, 
                            pos = 1)$geno))
                          seq.work <- pmatch(c(seq.init, rest.ord), input.seq$seq.num)
                        }
                        else if (FLAG == "f2") {
                          seq.type <- get(input.seq$data.name, pos = 1)$segr.type.num[seq.rest]
                          names(seq.type) <- names(seq.mis)
                          tp.ord <- sort(seq.type)
                          rest.ord <- c(sort(seq.mis[pmatch(names(tp.ord)[tp.ord == 
                            4], names(seq.mis))]), sort(seq.mis[pmatch(names(tp.ord)[tp.ord == 
                            5], names(seq.mis))]))
                          rest <- pmatch(names(rest.ord), colnames(get(input.seq$data.name, 
                            pos = 1)$geno))
                          seq.work <- pmatch(c(seq.init, rest), input.seq$seq.num)
                        }
                        else stop("Invalid cross type\n")
                    }
                    else if (subset.search == "sample") {
                        cat("\nCross type: ", cross.type, "\nChoosing initial subset using the 'sample' approach\n")
                        LOD.test <- i <- 0
                        while (abs(LOD.test) < abs(subset.THRES) && i < 
                          subset.n.try) {
                          smp.seq <- make_seq(get(input.seq$twopt), sample(input.seq$seq.num, 
                            size = n.init), twopt = input.seq$twopt)
                          res.test <- compare(smp.seq)
                          LOD.test <- res.test$best.ord.LOD[2]
                          i < -i + 1
                        }
                        if (abs(LOD.test) >= abs(subset.THRES)) {
                          seq.init <- res.test$best.ord[1, ]
                          seq.rest <- input.seq$seq.num[-pmatch(seq.init, 
                            input.seq$seq.num)]
                          seq.mis <- apply(as.matrix(get(input.seq$data.name, 
                            pos = 1)$geno[, seq.rest]), 2, function(x) sum(x == 
                            0))
                          names(seq.mis) <- colnames(get(input.seq$data.name, 
                            pos = 1)$geno)[seq.rest]
                          if (FLAG == "bc") {
                            rest.ord <- pmatch(names(seq.mis), colnames(get(input.seq$data.name, 
                              pos = 1)$geno))
                            seq.work <- pmatch(c(seq.init, rest.ord), 
                              input.seq$seq.num)
                          }
                          else if (FLAG == "f2") {
                            seq.type <- get(input.seq$data.name, pos = 1)$segr.type.num[seq.rest]
                            names(seq.type) <- names(seq.mis)
                            tp.ord <- sort(seq.type)
                            rest.ord <- c(sort(seq.mis[pmatch(names(tp.ord)[tp.ord == 
                              4], names(seq.mis))]), sort(seq.mis[pmatch(names(tp.ord)[tp.ord == 
                              5], names(seq.mis))]))
                            rest <- pmatch(names(rest.ord), colnames(get(input.seq$data.name, 
                              pos = 1)$geno))
                            seq.work <- pmatch(c(seq.init, rest), input.seq$seq.num)
                          }
                          else stop("Invalid cross type\n")
                        }
                        else stop("Cannot find any subset using 'subset.n.try'=", 
                          subset.n.try, " and 'subset.THRES'= ", subset.THRES, 
                          "\n")
                    }
                }
                else if (FLAG == "outcross") {
                    cat("\nCross type: outcross\nUsing segregation types of the markers to choose initial subset\n")
                    segregation.types <- get(input.seq$data.name, pos = 1)$segr.type.num[input.seq$seq.num]
                    if (sum(segregation.types == 7) > sum(segregation.types == 
                        6)) 
                        segregation.types[segregation.types == 6] <- 8
                    seq.work <- order(segregation.types)
                    seq.init <- input.seq$seq.num[seq.work[1:n.init]]
                }
                else stop("Invalid cross type")
                seq.ord <- compare(input.seq = make_seq(get(input.seq$twopt), 
                    seq.init, twopt = input.seq$twopt), n.best = 50)
                input.seq2 <- make_seq(seq.ord, 1)
                cat("\n\nRunning try algorithm\n")
                for (i in (n.init + 1):length(input.seq$seq.num)) {
                    time.elapsed <- system.time(seq.ord <- try_seq(input.seq2, input.seq$seq.num[seq.work[i]], tol = tol))[3]
                    if (time.elapsed < wait) 
                        Sys.sleep(wait - time.elapsed)
                    if (all(seq.ord$LOD[-which(seq.ord$LOD == max(seq.ord$LOD))[1]] < 
                        -THRES)) 
                        input.seq2 <- make_seq(seq.ord, which.max(seq.ord$LOD))
                }
                mrk.unpos <- input.seq$seq.num[which(is.na(match(input.seq$seq.num, 
                    input.seq2$seq.num)))]
                LOD.unpos <- NULL
                cat("\nLOD threshold =", THRES, "\n\nPositioned markers:", 
                    input.seq2$seq.num, "\n\n")
                cat("Markers not placed on the map:", mrk.unpos, "\n")
                if (touchdown && length(mrk.unpos) > 0) {
                    cat("\n\n\nTrying to map remaining markers with LOD threshold ", 
                        THRES - 1, "\n")
                    for (i in mrk.unpos) {
                        time.elapsed <- system.time(seq.ord <- try_seq(input.seq2, i, tol = tol))[3]
                        if (time.elapsed < wait) 
                          Sys.sleep(wait - time.elapsed)
                        if (all(seq.ord$LOD[-which(seq.ord$LOD == max(seq.ord$LOD))[1]] < 
                          (-THRES + 1))) 
                          input.seq2 <- make_seq(seq.ord, which.max(seq.ord$LOD))
                    }
                    mrk.unpos <- input.seq$seq.num[which(is.na(match(input.seq$seq.num, 
                        input.seq2$seq.num)))]
                    cat("\nLOD threshold =", THRES - 1, "\n\nPositioned markers:", 
                        input.seq2$seq.num, "\n\n")
                    cat("Markers not placed on the map:", mrk.unpos, 
                        "\n")
                }
                if (length(mrk.unpos) > 0) {
                    LOD.unpos <- matrix(NA, length(mrk.unpos), (length(input.seq2$seq.num) + 
                        1))
                    j <- 1
                    cat("\n\nCalculating LOD-Scores\n")
                    for (i in mrk.unpos) {
                        LOD.unpos[j, ] <- try_seq(input.seq = input.seq2, mrk = i, tol = tol)$LOD
                        j <- j + 1
                    }
                }
                else mrk.unpos <- NULL
                input.seq3 <- input.seq2
                if (!is.null(mrk.unpos)) {
                    cat("\n\nPlacing remaining marker(s) at most likely position\n")
                    which.order <- order(apply(LOD.unpos, 1, function(x) max(x[-which(x == 
                        0)[1]])))
                    for (i in mrk.unpos[which.order]) {
                        time.elapsed <- system.time(seq.ord <- try_seq(input.seq3, i, tol = tol))[3]
                        if (time.elapsed < wait) 
                          Sys.sleep(wait - time.elapsed)
                        input.seq3 <- make_seq(seq.ord, which(seq.ord$LOD == 
                          0)[sample(sum(seq.ord$LOD == 0))[1]])
                    }
                }
                cat("\nEstimating final genetic map using tol = 10E-5.\n\n")
                input.seq2 <- map(input.seq2, tol = 1e-04)
                input.seq3 <- map(input.seq3, tol = 1e-04)
                if (draw.try == TRUE) 
                    draw.order(input.seq3)
                structure(list(ord = input.seq2, mrk.unpos = mrk.unpos, 
                    LOD.unpos = LOD.unpos, THRES = THRES, ord.all = input.seq3, 
                    data.name = input.seq$data.name, twopt = input.seq$twopt), 
                    class = "order")
            }
    }
    else {
        if(any(is.na(pmatch(framed.num, input.seq$seq.num))))
            stop("Some sequence numbers in " , deparse(substitute(framed.num)), " do not belong to linkage group ", 
                deparse(substitute(input.seq)),".")
        cross.type <- class(get(input.seq$data.name, pos = 1))[2]
        if (cross.type == "f2") FLAG <- "f2"
        else if (cross.type == "backcross" || 
        	cross.type == "riself" || 
        	cross.type == "risib") FLAG <- "bc"
        else if (cross.type == "outcross") FLAG <- "outcross"
        else stop("Invalid cross type\n")
        seq.init <- make_seq(get(input.seq$twopt), framed.num, twopt = input.seq$twopt) # Luciano # 
        seq.ord <- map(seq.init) # Luciano #
        input.seq2 <- seq.ord # Luciano #
        seq.matc <- pmatch(framed.num, input.seq$seq.num)
        if (FLAG == "bc" || FLAG == "f2") {
             seq.work <- input.seq$seq.num[-seq.matc] # Luciano #
        }
        else if (FLAG == "outcross") {
             seq.work <- input.seq$seq.num[-seq.matc]
             segregation.types <- get(input.seq$data.name, pos = 1)$segr.type.num[seq.work]
             if (sum(segregation.types == 7) > sum(segregation.types == 6)) 
                segregation.types[segregation.types == 6] <- 8
                seq.work <- seq.work[order(segregation.types)]
       }
        else stop("Invalid cross type")
        cat("\n\nRunning try algorithm\n")        
        if (length(input.seq$seq.num)-length(framed.num)) {
        	##Including the if statement above to fix S1424542##
	        for (i in 1:(length(input.seq$seq.num)-length(framed.num))) { #Luciano#
	            time.elapsed <- system.time(seq.ord <- try_seq(input.seq2, seq.work[i], tol = tol))[3]
	            if (time.elapsed < wait) 
	                Sys.sleep(wait - time.elapsed)
	            if (all(seq.ord$LOD[-which(seq.ord$LOD == max(seq.ord$LOD))[1]] < 
	                -THRES)) 
	                input.seq2 <- make_seq(seq.ord, which.max(seq.ord$LOD))
	        }
        }
        mrk.unpos <- input.seq$seq.num[which(is.na(match(input.seq$seq.num, 
            input.seq2$seq.num)))]
        LOD.unpos <- NULL
        cat("\nLOD threshold =", THRES, "\n\nPositioned markers:", 
            input.seq2$seq.num, "\n\n")
        cat("Markers not placed on the map:", mrk.unpos, "\n")
        if (touchdown && length(mrk.unpos) > 0) {
            cat("\n\n\nTrying to map remaining markers with LOD threshold ", 
                THRES - 1, "\n")
            for (i in mrk.unpos) {
                time.elapsed <- system.time(seq.ord <- try_seq(input.seq2, i, tol = tol))[3]
                if (time.elapsed < wait) 
                  Sys.sleep(wait - time.elapsed)
                if (all(seq.ord$LOD[-which(seq.ord$LOD == max(seq.ord$LOD))[1]] < 
                  (-THRES + 1))) 
                  input.seq2 <- make_seq(seq.ord, which.max(seq.ord$LOD))
            }
            mrk.unpos <- input.seq$seq.num[which(is.na(match(input.seq$seq.num, 
                input.seq2$seq.num)))]
            cat("\nLOD threshold =", THRES - 1, "\n\nPositioned markers:", 
                input.seq2$seq.num, "\n\n")
            cat("Markers not placed on the map:", mrk.unpos, 
                "\n")
        }
        if (length(mrk.unpos) > 0) {
            LOD.unpos <- matrix(NA, length(mrk.unpos), (length(input.seq2$seq.num) + 
                1))
            j <- 1
            cat("\n\nCalculating LOD-Scores\n")
            for (i in mrk.unpos) {
                LOD.unpos[j, ] <- try_seq(input.seq = input.seq2, mrk = i, tol = tol)$LOD
                j <- j + 1
            }
        }
        else mrk.unpos <- NULL
        input.seq3 <- input.seq2
        if (!is.null(mrk.unpos)) {
            cat("\n\nPlacing remaining marker(s) at most likely position\n")
            which.order <- order(apply(LOD.unpos, 1, function(x) max(x[-which(x == 
                0)[1]])))
            for (i in mrk.unpos[which.order]) {
                time.elapsed <- system.time(seq.ord <- try_seq(input.seq3, i, tol = tol))[3]
                if (time.elapsed < wait) 
                  Sys.sleep(wait - time.elapsed)
                input.seq3 <- make_seq(seq.ord, which(seq.ord$LOD == 
                  0)[sample(sum(seq.ord$LOD == 0))[1]])
            }
        }
        cat("\nEstimating final genetic map using tol = 10E-5.\n\n")
        input.seq2 <- map(input.seq2, tol = 1e-04)
        input.seq3 <- map(input.seq3, tol = 1e-04)
        if (draw.try == TRUE) 
            draw.order(input.seq3)
        structure(list(ord = input.seq2, mrk.unpos = mrk.unpos, 
            LOD.unpos = LOD.unpos, THRES = THRES, ord.all = input.seq3, 
            data.name = input.seq$data.name, twopt = input.seq$twopt), 
            class = "order")
    
    }
}

#######################################################################
#                                                                     #
# Function: codif.data.adpt                                           #
#                                                                     #
# Adapted from codif.data (found in the R package onemap)             #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2009, Marcelo Mollinari                               #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################
codif.data.adpt <- function (geno.in, segr.type.in) {
    geno.out <- matrix(NA, nrow(geno.in), ncol(geno.in))
    segr.type.out <- rep(NA, length(segr.type.in))
    geno.out[which(geno.in==0)] <- " "
    for (i in 1:length(segr.type.in)) {
        switch(EXPR = segr.type.in[i], A.1 = {
            geno.out[which(geno.in[, i] == 1), i] <- "ac"
            geno.out[which(geno.in[, i] == 2), i] <- "ad"
            geno.out[which(geno.in[, i] == 3), i] <- "bc"
            geno.out[which(geno.in[, i] == 4), i] <- "bd"
            segr.type.out[i] <- 1
        }, A.2 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "ac"
            geno.out[which(geno.in[, i] == 3), i] <- "ba"
            geno.out[which(geno.in[, i] == 4), i] <- "bc"
            segr.type.out[i] <- 1
        }, A.3 = {
            geno.out[which(geno.in[, i] == 1), i] <- "ac" 
            geno.out[which(geno.in[, i] == 2), i] <- "a"
            geno.out[which(geno.in[, i] == 3), i] <- "bc"
            geno.out[which(geno.in[, i] == 4), i] <- "b"
            segr.type.out[i] <- 1
        }, A.4 = {
            geno.out[which(geno.in[, i] == 1), i] <- "ab"
            geno.out[which(geno.in[, i] == 2), i] <- "a"
            geno.out[which(geno.in[, i] == 3), i] <- "b"
            geno.out[which(geno.in[, i] == 4), i] <- "o"
            segr.type.out[i] <- 1
        }, B1.5 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "ab"
            geno.out[which(geno.in[, i] == 3), i] <- "b"
            segr.type.out[i] <- 2
        }, B2.6 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "ab"
            geno.out[which(geno.in[, i] == 3), i] <- "b"
            segr.type.out[i] <- 3
        }, B3.7 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "ab"
            geno.out[which(geno.in[, i] == 3), i] <- "b"
            segr.type.out[i] <- 4
        }, C.8 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "o"
            segr.type.out[i] <- 5
        }, D1.9 = {
            geno.out[which(geno.in[, i] == 1), i] <- "ac"
            geno.out[which(geno.in[, i] == 2), i] <- "bc"
            segr.type.out[i] <- 6
        }, D1.10 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "ab"
            segr.type.out[i] <- 6
        }, D1.11 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "b"
            segr.type.out[i] <- 6
        }, D1.12 = {
            geno.out[which(geno.in[, i] == 1), i] <- "ab"
            geno.out[which(geno.in[, i] == 2), i] <- "a"
            segr.type.out[i] <- 6
        }, D1.13 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "o"
            segr.type.out[i] <- 6
        }, D2.14 = {
            geno.out[which(geno.in[, i] == 1), i] <- "ac"
            geno.out[which(geno.in[, i] == 2), i] <- "bc"
            segr.type.out[i] <- 7
        }, D2.15 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "ab"
            segr.type.out[i] <- 7
        }, D2.16 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "b"
            segr.type.out[i] <- 7
        }, D2.17 = {
            geno.out[which(geno.in[, i] == 1), i] <- "ab"
            geno.out[which(geno.in[, i] == 2), i] <- "a"
            segr.type.out[i] <- 7
        }, D2.18 = {
            geno.out[which(geno.in[, i] == 1), i] <- "a"
            geno.out[which(geno.in[, i] == 2), i] <- "o"
            segr.type.out[i] <- 7
        })
        if (any(is.na(geno.out[, i]))) 
            stop(paste("Invalid marker codification. Please check data for marker", 
                colnames(geno.in)[i]), ".", sep = "")
    }
    dimnames(geno.out) <- dimnames(geno.in)
    return(list(geno=geno.out, segr.type=segr.type.out))
}

#######################################################################
#                                                                     #
# Function: ripple.seq.adpt                                           #
#                                                                     #
# Adapted from ripple.seq (found in the R package onemap)             #
# Written by Luciano da Costa e Silva                                 #
# copyright (c) 2009, Gabriel R A Margarido                           #
#                                                                     #
# First version: Nov 2013                                             #
# Last update: Nov 2013                                               #
# License: GNU General Public License version 2 (June, 1991) or later #
#                                                                     #
#######################################################################

ripple.seq.adpt <- function (input.seq, ws = 4, LOD = 3, tol = 0.1, verbose = FALSE) 
{
    if (!any(class(input.seq) == "sequence")) 
        stop(deparse(substitute(input.seq)), " is not an object of class 'sequence'")
    if (ws < 2) 
        stop("ws must be greater than or equal to 2")
    if (ws > 5) 
        cat("WARNING: this operation may take a VERY long time\n\n")
    flush.console()
    len <- length(input.seq$seq.num)
    if (len <= ws) 
        stop("Length of sequence ", deparse(substitute(input.seq)), 
            " is smaller than ws. You can use the compare function instead")
    flag.best.seq <- 0 # Luciano
    link.phases <- matrix(NA, len, 2)
    link.phases[1, ] <- rep(1, 2)
    for (i in 1:length(input.seq$seq.phases)) {
        switch(EXPR = input.seq$seq.phases[i], 
        	link.phases[i + 1, ] <- link.phases[i, ] * c(1, 1), 
        	link.phases[i + 1, ] <- link.phases[i, ] * c(1, -1),
        	link.phases[i + 1, ] <- link.phases[i, ] * c(-1, 1), 
        	link.phases[i + 1, ] <- link.phases[i, ] * c(-1, -1), 
        	)
    }
    rf.init <- rep(NA, len - 1)
    phase <- rep(NA, len - 1)
    tot <- prod(1:ws)
    best.ord.rf <- matrix(NA, tot, len - 1) #Luciano
    best.ord.phase <- matrix(NA, tot, len - 1)
    best.ord.like <- best.ord.LOD <- rep(-Inf, tot)
    list.init <- phases(input.seq)
    if (verbose) { #Luciano
   	 cat(input.seq$seq.num, "\n") #Luciano
   	 cat(input.seq$seq.num[1:ws], "...")
    } #Luciano
    all.ord <- t(apply(perm_tot(head(input.seq$seq.num, ws)), 1, function(x) c(x, tail(input.seq$seq.num, -ws))))
    for (i in 1:nrow(all.ord)) {
        all.match <- match(all.ord[i, ], input.seq$seq.num)
        for (j in 1:ws) {
            temp <- paste(as.character(link.phases[all.match[j], ] * link.phases[all.match[j + 1], ]), collapse = ".")
            phase[j] <- switch(EXPR = temp, `1.1` = 1, `1.-1` = 2, `-1.1` = 3, `-1.-1` = 4)
        }
        if (len > (ws + 1)) 
            phase[(ws + 1):length(phase)] <- tail(input.seq$seq.phase, -ws)
        for (j in 1:(len - 1)) {
            if (all.match[j] > all.match[j + 1]) 
                ind <- acum(all.match[j] - 2) + all.match[j + 1]
            else ind <- acum(all.match[j + 1] - 2) + all.match[j]
            if (length(which(list.init$phase.init[[ind]] == phase[j])) == 0) 
                rf.init[j] <- 0.49
            else rf.init[j] <- list.init$rf.init[[ind]][which(list.init$phase.init[[ind]] == phase[j])]
        }
        #### Prior to OneMap version 2.1.1  ####
        #final.map <- est.map.c(geno = get(input.seq$data.name, pos = 1)$geno[, all.ord[i, ]], 
        #			type = get(input.seq$data.name, pos = 1)$segr.type.num[all.ord[i, ]], 
        #			phase = phase, rec = rf.init, verbose = FALSE, tol = tol)
        ########################################
        
        #### OneMap version 2.1.1 #### 
        final.map <- est_map_hmm_out(geno=t(get(input.seq$data.name, pos=1)$geno[,all.ord[i,]]),
                                     type=get(input.seq$data.name, pos=1)$segr.type.num[all.ord[i,]],
                                     phase=phase, rf.vec=rf.init, verbose=FALSE, tol=tol)
        ##############################
                                     
        best.ord.phase[i, ] <- phase
        best.ord.like[i] <- final.map$loglike
        best.ord.rf[i, ] <- final.map$rf #Luciano
        if (all(all.ord[i,]==input.seq$seq.num)) { #Luciano
        	input.ord.i <- i #Luciano
        	input.sarf <- sum(best.ord.rf[i, ])
        	input.like <- best.ord.like[i]
        } #Luciano
    }
    best.ord.LOD <- round((best.ord.like - input.like)/log(10), 2) #Luciano
    which.LOD <- which(best.ord.LOD > LOD) #Luciano
    if (length(which.LOD) >= 1) { #Luciano    
    #best.ord.LOD <- round((best.ord.like - max(best.ord.like))/log(10), 2)
    #which.LOD <- which(best.ord.LOD > -LOD)
    #if (length(which.LOD) > 1) {
    
        order.print <- order(best.ord.LOD, decreasing = TRUE)
        all.ord <- all.ord[order.print, ]
        best.ord.phase <- best.ord.phase[order.print, ]
        best.ord.LOD <- best.ord.LOD[order.print]
        best.ord.rf <- best.ord.rf[order.print, ] #Luciano
        #which.LOD <- which(best.ord.LOD > -LOD)
        which.LOD <- which(best.ord.LOD > LOD) #Luciano
        LOD.print <- format(best.ord.LOD, digits = 2, nsmall = 2)
        if (verbose) { #Luciano
 	       cat("\n  Alternative orders:\n")
 	       for (j in which.LOD) {
 	           if (class(get(input.seq$data.name, pos = 1))[2] == "outcross") 
 	           	cat(	"  ", 
 	           		all.ord[j, 1:(ws + 1)], 
 	           		ifelse(len > (ws + 1), "... : ", ": "), 
 	           		LOD.print[j], "( linkage phases:", 
 	                 	best.ord.phase[j, 1:ws], 
 	                 	ifelse(len > (ws + 1), "... )\n", ")\n"))
 	           else cat(	"  ", 
 	           		all.ord[j, 1:(ws + 1)], 
 	           		ifelse(len > (ws + 1), "... : ", ": "), 
 	           		LOD.print[j], "\n")
 	       }
 	       cat("\n")
	} #Luciano
      	if (sum(best.ord.rf[1, ]) < input.sarf) { #Luciano
      	shuffled.map <- input.seq
      	shuffled.map$seq.num <- all.ord[1, ] #Luciano
      	shuffled.map$seq.phases <- best.ord.phase[1, ] #Luciano
      	#shuffled.map$seq.rf <- best.ord.rf[1, ] #Luciano
      	#shuffled.map$seq.phases <- -1 #Luciano
      	shuffled.map$seq.rf <- -1 #Luciano 
      	shuffled.map$seq.like <- NULL #Luciano 
      	shuffled.map <- map(shuffled.map, tol=0.0001)
      	#cat("\n", input.sarf, sum(best.ord.rf[1, ]), sum(input.seq$seq.rf), sum(shuffled.map$seq.rf), "\n")
      	cat("Input Map SARF= ", format(sum(input.seq$seq.rf), digits = 2, nsmall = 3), 
      		", Shuffled Map SARF= ", format(sum(shuffled.map$seq.rf), digits = 2, nsmall = 3), 
      		ifelse(sum(shuffled.map$seq.rf) < sum(input.seq$seq.rf), "OK", " "),
      		"\n")
      	if (sum(shuffled.map$seq.rf) < sum(input.seq$seq.rf)) {
      		input.seq <- shuffled.map
      		flag.best.seq <- 1
      		}
      	} #Luciano
    }
    else {
    	if (verbose) { #Luciano
    	cat(" OK\n\n")
    	} #Luciano
    }
    if (len > (ws + 1)) {
        for (p in 2:(len - ws)) {
            list.init <- phases(input.seq) #Luciano
            if (verbose) { #Luciano
            cat(input.seq$seq.num, "\n") #Luciano
            cat(input.seq$seq.num[p:(p + ws - 1)], "...")
            } #Luciano
            all.ord <- t(apply(perm_tot(input.seq$seq.num[p:(p + ws - 1)]), 1, function(x) c(head(input.seq$seq.num, p - 1), x, tail(input.seq$seq.num, -p - ws + 1))))
            for (i in 1:nrow(all.ord)) {
                all.match <- match(all.ord[i, ], input.seq$seq.num)
                if (p > 2) 
                  phase[1:(p - 2)] <- head(input.seq$seq.phase, p - 2)
                for (j in (p - 1):(p + ws - 1)) {
                  temp <- paste(as.character(link.phases[all.match[j], ] * link.phases[all.match[j + 1], ]), collapse = ".")
                  phase[j] <- switch(EXPR = temp, `1.1` = 1, `1.-1` = 2, `-1.1` = 3, `-1.-1` = 4)
                }
                if (p < (len - ws)) 
                  phase[(p + ws):length(phase)] <- tail(input.seq$seq.phase, len - p - ws)
                for (j in 1:(len - 1)) {
                  if (all.match[j] > all.match[j + 1]) 
                    ind <- acum(all.match[j] - 2) + all.match[j + 1]
                  else ind <- acum(all.match[j + 1] - 2) + all.match[j]
                  if (length(which(list.init$phase.init[[ind]] == phase[j])) == 0) 
                    rf.init[j] <- 0.49
                  else rf.init[j] <- list.init$rf.init[[ind]][which(list.init$phase.init[[ind]] == phase[j])]
                }
        	#### Prior to OneMap version 2.1.1  ####
                #final.map <- est.map.c(geno = get(input.seq$data.name, pos = 1)$geno[, all.ord[i, ]], 
                #			type = get(input.seq$data.name, pos = 1)$segr.type.num[all.ord[i, ]], 
                #			phase = phase, rec = rf.init, verbose = FALSE, tol = tol)
        	########################################
        
        	#### OneMap version 2.1.1 #### 
        	final.map <- est_map_hmm_out(geno=t(get(input.seq$data.name, pos=1)$geno[,all.ord[i,]]),
                                     type=get(input.seq$data.name, pos=1)$segr.type.num[all.ord[i,]],
                                     phase=phase, rf.vec=rf.init, verbose=FALSE, tol=tol)
        	##############################
       
                best.ord.phase[i, ] <- phase
                best.ord.like[i] <- final.map$loglike
     		   best.ord.rf[i, ] <- final.map$rf #Luciano
     		   if (all(all.ord[i,]==input.seq$seq.num)) { #Luciano
     		   	input.ord.i <- i #Luciano
        		input.sarf <- sum(best.ord.rf[i, ])
        		input.like <- best.ord.like[i]
     		   } #Luciano
            }
  		best.ord.LOD <- round((best.ord.like - input.like)/log(10), 2) #Luciano
   		which.LOD <- which(best.ord.LOD > LOD) #Luciano
   		if (length(which.LOD) >= 1) { #Luciano
            #best.ord.LOD <- round((best.ord.like - max(best.ord.like))/log(10), 2)
            #which.LOD <- which(best.ord.LOD > -LOD)
            #if (length(which.LOD) > 1) {
                order.print <- order(best.ord.LOD, decreasing = TRUE)
                all.ord <- all.ord[order.print, ]
                best.ord.phase <- best.ord.phase[order.print, ]
                best.ord.LOD <- best.ord.LOD[order.print]
                best.ord.rf <- best.ord.rf[order.print, ] #Luciano
                #which.LOD <- which(best.ord.LOD > -LOD)
                which.LOD <- which(best.ord.LOD > LOD) #Luciano
                LOD.print <- format(best.ord.LOD, digits = 2, nsmall = 2)
                if (verbose) { #Luciano
                cat("\n  Alternative orders:\n")
                for (j in which.LOD) {
                  if (class(get(input.seq$data.name, pos = 1))[2] == "outcross") 
                  	cat(	ifelse(p > 2, "  ...", "  "), 
                    		all.ord[j, (p - 1):(p + ws)], 
                    		ifelse((p + ws) < len, "... : ", ": "), 
                    		LOD.print[j], "( linkage phases:", 
                      		ifelse(p > 2, "...", "\b"), 
                      		best.ord.phase[j, (p - 1):(p + ws - 1)], 
                      		ifelse((p + ws) < len, "... )\n", ")\n")
                      	)
                  else cat(	ifelse(p > 2, "  ...", "  "), 
                  		all.ord[j, (p - 1):(p + ws)], 
                  		ifelse((p + ws) < len, "... : ", ": "), 
                  		LOD.print[j], "\n")
                }
                cat("\n")
                } #Luciano
                if (sum(best.ord.rf[1, ]) < input.sarf) { #Luciano
                shuffled.map <- input.seq
       		shuffled.map$seq.num <- all.ord[1, ] #Luciano
        	shuffled.map$seq.phases <- best.ord.phase[1, ] #Luciano
        	#shuffled.map$seq.rf <- best.ord.rf[1, ] #Luciano
        	#shuffled.map$seq.phases <- -1 #Luciano
        	shuffled.map$seq.rf <- -1 #Luciano 
        	shuffled.map$seq.like <- NULL #Luciano 
                shuffled.map <- map(shuffled.map, tol=0.0001)
                #cat("\n", input.sarf, sum(best.ord.rf[1, ]), sum(input.seq$seq.rf), sum(shuffled.map$seq.rf), "\n")
                cat("Input Map SARF= ", format(sum(input.seq$seq.rf), digits = 2, nsmall = 3), 
                	", Shuffled Map SARF= ", format(sum(shuffled.map$seq.rf), digits = 2, nsmall = 3), 
                	ifelse(sum(shuffled.map$seq.rf) < sum(input.seq$seq.rf), "OK", " "),
                	"\n")
                if (sum(shuffled.map$seq.rf) < sum(input.seq$seq.rf)) {
                	input.seq <- shuffled.map
                	flag.best.seq <- 1
               		}
        	} #Luciano
            }
            else {
            if (verbose) { #Luciano
            cat(" OK\n\n")
            } #Luciano
            }
        }
    }
    list.init <- phases(input.seq) #Luciano
    if (verbose) { #Luciano
    cat(input.seq$seq.num, "\n") #Luciano
    cat(tail(input.seq$seq.num, ws), "...")
    } #Luciano
    all.ord <- t(apply(perm_tot(tail(input.seq$seq.num, ws)), 1, function(x) c(head(input.seq$seq.num, -ws), x)))
    for (i in 1:nrow(all.ord)) {
        all.match <- match(all.ord[i, ], input.seq$seq.num)
        if (len > (ws + 1)) 
            phase[1:(len - ws - 1)] <- head(input.seq$seq.phase, -ws)
        for (j in (len - ws):(len - 1)) {
            temp <- paste(as.character(link.phases[all.match[j], ] * link.phases[all.match[j + 1], ]), collapse = ".")
            phase[j] <- switch(EXPR = temp, `1.1` = 1, `1.-1` = 2, `-1.1` = 3, `-1.-1` = 4)
        }
        for (j in 1:(len - 1)) {
            if (all.match[j] > all.match[j + 1]) 
                ind <- acum(all.match[j] - 2) + all.match[j + 1]
            else ind <- acum(all.match[j + 1] - 2) + all.match[j]
            if (length(which(list.init$phase.init[[ind]] == phase[j])) == 0) 
                rf.init[j] <- 0.49
            else rf.init[j] <- list.init$rf.init[[ind]][which(list.init$phase.init[[ind]] == phase[j])]
        }
        #### Prior to OneMap version 2.1.1  ####
        #final.map <- est.map.c(geno = get(input.seq$data.name, pos = 1)$geno[, all.ord[i, ]], 
        #			type = get(input.seq$data.name, pos = 1)$segr.type.num[all.ord[i, ]], 
        #			phase = phase, rec = rf.init, verbose = FALSE, tol = tol)
        ########################################
        
        #### OneMap version 2.1.1 #### 
        final.map <- est_map_hmm_out(geno=t(get(input.seq$data.name, pos=1)$geno[,all.ord[i,]]),
                                     type=get(input.seq$data.name, pos=1)$segr.type.num[all.ord[i,]],
                                     phase=phase, rf.vec=rf.init, verbose=FALSE, tol=tol)
        ##############################
        
        best.ord.phase[i, ] <- phase
        best.ord.like[i] <- final.map$loglike
        best.ord.rf[i, ] <- final.map$rf #Luciano
        if (all(all.ord[i,]==input.seq$seq.num)) { #Luciano
        	input.ord.i <- i #Luciano
        	input.sarf <- sum(best.ord.rf[i, ])
        	input.like <- best.ord.like[i]
        } #Luciano
    }
    best.ord.LOD <- round((best.ord.like - input.like)/log(10), 2) #Luciano
    which.LOD <- which(best.ord.LOD > LOD) #Luciano
    if (length(which.LOD) >= 1) { #Luciano
    #best.ord.LOD <- round((best.ord.like - max(best.ord.like))/log(10), 2)
    #which.LOD <- which(best.ord.LOD > -LOD)
    #if (length(which.LOD) > 1) {
        order.print <- order(best.ord.LOD, decreasing = TRUE)
        all.ord <- all.ord[order.print, ]
        best.ord.phase <- best.ord.phase[order.print, ]
        best.ord.LOD <- best.ord.LOD[order.print]
        best.ord.rf <- best.ord.rf[order.print, ] #Luciano
        #which.LOD <- which(best.ord.LOD > -LOD)
        which.LOD <- which(best.ord.LOD > LOD) #Luciano
        LOD.print <- format(best.ord.LOD, digits = 2, nsmall = 2)
        if (verbose) { #Luciano
        cat("\n  Alternative orders:\n")
        for (j in which.LOD) {
            if (class(get(input.seq$data.name, pos = 1))[2] == "outcross") 
		cat(	ifelse(len > (ws + 1), "  ...", "  "), 
                	all.ord[j, (len - ws):len], ": ", 
                	LOD.print[j], "( linkage phases:", 
                  	ifelse(len > (ws + 1), "...", "\b"), 
                  	best.ord.phase[j, (len - ws):(len - 1)], ")\n")
            else cat(	ifelse(len > (ws + 1), "  ...", "  "), 
            		all.ord[j, (len - ws):len], ": ", 
            		LOD.print[j], "\n")
        }
        cat("\n")
        } #Luciano
                if (sum(best.ord.rf[1, ]) < input.sarf) { #Luciano
                shuffled.map <- input.seq
       		shuffled.map$seq.num <- all.ord[1, ] #Luciano
        	shuffled.map$seq.phases <- best.ord.phase[1, ] #Luciano
        	#shuffled.map$seq.rf <- best.ord.rf[1, ] #Luciano
        	#shuffled.map$seq.phases <- -1 #Luciano
        	shuffled.map$seq.rf <- -1 #Luciano 
        	shuffled.map$seq.like <- NULL #Luciano 
                shuffled.map <- map(shuffled.map, tol=0.0001)
                #cat("\n", input.sarf, sum(best.ord.rf[1, ]), sum(input.seq$seq.rf), sum(shuffled.map$seq.rf), "\n")
                cat("Input Map SARF= ", format(sum(input.seq$seq.rf), digits = 2, nsmall = 3), 
                	", Shuffled Map SARF= ", format(sum(shuffled.map$seq.rf), digits = 2, nsmall = 3), 
                	ifelse(sum(shuffled.map$seq.rf) < sum(input.seq$seq.rf), "OK", " "),
                	"\n")
                if (sum(shuffled.map$seq.rf) < sum(input.seq$seq.rf)) {
                	input.seq <- shuffled.map
                	flag.best.seq <- 1
               		}
        	} #Luciano
    }
    else {
    if (verbose) { #Luciano
    cat(" OK\n\n")
    } #Luciano
    }
    #if (flag.best.seq) { #Luciano
    #	final.map <- est.map.c(geno = get(input.seq$data.name, pos = 1)$geno[, input.seq$seq.num], 
    #     			type = get(input.seq$data.name, pos = 1)$segr.type.num[input.seq$seq.num], 
    #     			phase = input.seq$seq.phases, rec = input.seq$seq.rf, verbose = FALSE, tol = 0.0001)
    #   	input.seq$seq.rf <- final.map$rf
    #   	input.seq$seq.like <- final.map$loglike
    #} #Luciano
    return(input.seq)
}