/*
JMP Genomics Analytical Process

Name: Genomic Bayesian Regression
Author: Luciano Silva, SAS Institute Inc.
History:
   sbrlsi 06Aug18 initial coding
*/

/*
-----------------------------------------------------------
Copyright (C) 2018 SAS Institute, Inc. All rights reserved. 

Notice: 
The above copyright notice and this notice must appear in
any whole or partial copy of this code and any related
documentation. Permission to use, copy, and modify the
source code contained in this file is hereby granted, but
is limited to customers of SAS with a valid license for the
SAS software product with which this file was provided. 
Except as expressly set forth herein, the terms of such
license apply.
-----------------------------------------------------------
*/

*ProcessVariables;


%let StudyName=%nrbquote();
%let InData=%nrbquote($LS_HOME\Sample Data\Genetics\samplegmdata_numgeno.sas7bdat);
%let ClassVar= disease;
%let MarkerVars= ;
%let PredictorVars= Qtrt1 Qtrt2 Qtrt3 Qtrt4;
%let ClassPredVars= sex;
%let WeightVar= ;
%let GroupsVar= ;
%let LabelVar= Ped_id;
%let ListMarkerVars=%nrbquote(numgeno:);
%let ListContPredVars=%nrbquote();
%let ListClassPredVars=%nrbquote();
%let OutPath=%nrbquote($HOME/JMPLS/ProcessResults/);
%let MacroPath= $GENOMICS_HOME\MacroLib;
%let LockMarkerVars= ;
%let LockContPredVars= ;
%let LockClassPredVars= ;
%let ListLockMarkerVars=%nrbquote();
%let ListLockContPredVars=%nrbquote();
%let ListLockClassPredVars=%nrbquote();
%let PredWhere=%nrbquote();
%let DataStepStatements=%str();
%let StandardizationMethod=%nrbquote();
%let NumArg= ;
%let ImputeZeros= No;
%let StatTest= No;
%let ST_Max= ;
%let ST_Method= ;
%let ST_AsymmetricLossFitProp= ;
%let ST_QuantileLevel= ;
%let MultipleTestingMethod= ;
%let NegLog10pCutoff= ;
%let AbsMeanDiffCutoff= ;
%let AbsPropDiffCutoff= ;
%let KMeans= No;
%let KM_Max= ;
%let KM_CorrRadius= ;
%let FR_ImpVars= No;
%let FR_NImpVars= ;
%let FR_MaxDepth= ;
%let FR_LeafSize= ;
%let FR_Seed= ;
%let FR_MaxTrees= ;
%let FR_NInputs= ;
%let RG_SelectMethod=%nrbquote(None);
%let RG_Adaptive= ;
%let RG_StopCriterion= ;
%let RG_SLEntry= ;
%let RG_SLStay= ;
%let RG_CVPMethod= ;
%let RG_CVKFold= ;
%let RG_MaxStep= ;
%let RG_Poolwise= ;
%let RG_PoolSize= ;
%let RG_PoolMax= ;
%let RG_ModelAveraging= ;
%let RG_MA_NSamples= ;
%let RG_MA_Max= ;
%let RG_MaxRounds= ;
%let RG_Seed= ;
%let Optimize= No;
%let Opt_Similarity= ;
%let Opt_Criterion= ;
%let Opt_Algorithm= ;
%let TraitType=%nrbquote(Binary);
%let BayesModel=%nrbquote(BayesianLASSO);
%let NumbIter= 10000;
%let NumbBurn= 2000;
%let ThinRate= 5;
%let S0Par= ;
%let DF0Par= ;
%let R2Par= 0.5;
%let CensorLBVar= ;
%let CensorUBVar= ;
%let TestInData=%nrbquote();
%let ClassVariables=%nrbquote();
%let FixedEffects=%nrbquote();
%let PedVars= ;
%let ListPedVars=%nrbquote();
%let IncreaseRMemory= No;
%let RMemorySize= ;
%let GBRegression_OutData=%nrbquote();
%let GBRegression_OutDataVars= ;
%let GBRegression_Script=%nrbquote();
%let GENOMICS_HOME=%nrbquote($GENOMICS_HOME\);

*ProcessBody;

%include "$GENOMICS_HOME\ProcessLibrary\GenomicBayesianRegression.sas"; 