/*
JMP Life Sciences Analytical Process

Name: PredictiveModelingReview
Author: Russ Wolfinger, SAS Institute Inc.
History:
   sasrdw 07Nov13 initial coding  

Description: 
	This process sets up a predictive modeling review.
*/

/*
-----------------------------------------------------------
Copyright (C) 2013 SAS Institute, Inc. All rights reserved. 

Notice: 
The above copyright notice and this notice must appear in
any whole or partial copy of this code and any related
documentation. Permission to use, copy, and modify the
source code contained in this file is hereby granted, but
is limited to customers of SAS with a valid license for the
SAS software product with which this file was provided. 
Except as expressly set forth herein, the terms of such
license apply.
-----------------------------------------------------------
*/

*ProcessVariables;


%let StudyName=%nrbquote();
%let InData=%nrbquote($LS_HOME\Sample Data\Genetics\samplegmdata_numgeno.sas7bdat);
%let ClassVar= disease;
%let PredictorVars= Qtrt1 Qtrt2 Qtrt3 Qtrt4;
%let ClassPredVars= sex;
%let WeightVar= ;
%let LabelVar= ;
%let ListContPredVars=%nrbquote(numgeno:);
%let ListClassPredVars=%nrbquote();
%let OutPath=%nrbquote($HOME\JMPLS\ProcessResults\);
%let MacroPath= $LS_HOME\MacroLib;
%let Priors= Proportional;
%let CustomCosts=%nrbquote();
%let LockContPredVars= ;
%let LockClassPredVars= ;
%let ListLockContPredVars=%nrbquote();
%let ListLockClassPredVars=%nrbquote();
%let CurrentReview= All Default;
%let IndividualModelFits= Yes;
%let DoCVMC= Yes;
%let CVMethod= Random Partition;
%let HOSize= K for K-Fold or 1/K Hold-Out;
%let KFold= 2;
%let LOut= ;
%let HOPct= ;
%let HONum= 2;
%let CVSeed= 283049751;
%let TestInPath=%nrbquote();
%let TestInDatas= ;
%let TS_ChartByTestSet= Yes;
%let TS_ChartByModel= No;
%let DoLCMC= No;
%let LC_InnerNum= ;
%let LC_NMin= ;
%let LC_NMax= ;
%let LC_OuterNum= ;
%let LC_InnerLoop= ;
%let LC_TestSet= ;
%let LC_FixedTestSet= ;
%let LC_Seed= ;
%let LC_CVMethod= ;
%let LC_HOSize= ;
%let LC_KFold= ;
%let LC_LOut= ;
%let LC_HOPct= ;
%let LC_HONum= ;
%let Server= Local;
%let LS_HOME=%nrbquote($LS_HOME\);
%let CLIENT_LS_HOME=%nrbquote($LS_HOME\);
%let USER_HOME=%nrbquote($HOME\JMPLS\);
%let LSUSER_HOME=%nrbquote($HOME\JMPLS\);
%let CLIENT_USER_HOME=%nrbquote($HOME\JMPLS\);
%let CLIENT_LSUSER_HOME=%nrbquote($HOME\JMPLS\);
%let Metapath=%nrbquote($HOME\JMPLS\);
%let Starter_Index=%nrbquote(1);
%let LS_Product=%nrbquote(Life Sciences);
%let CLIENT_HOST= Windows;


*ProcessBody;
%macro runAP;  
filename customap "$HOME\JMPLS\ProcessLibrary/PredictiveModelingReview.sas";
%if %sysfunc(fexist(customap)) %then %do;
   %include customap;
%end;
%else %do;
   %include "$LS_HOME\ProcessLibrary/PredictiveModelingReview.sas";
%end;
%mend;
%runAP;
      