/*
JMP Genomics Analytical Process

Name: Genomic Heritability
Author: Luciano Silva

Description:
Genomic Heritability calculates the proportion of 
genetic variance explained by SNPs, as described in 
Yang, J. et al. (Nature Genetics, 42: 565-569, 2010).
*/

/*
-----------------------------------------------------------
Copyright (C) 2017 SAS Institute, Inc. All rights reserved. 

Notice: 
The above copyright notice and this notice must appear in
any whole or partial copy of this code and any related
documentation. Permission to use, copy, and modify the
source code contained in this file is hereby granted, but
is limited to customers of SAS with a valid license for the
SAS software product with which this file was provided. 
Except as expressly set forth herein, the terms of such
license apply.
-----------------------------------------------------------
*/

*ProcessVariables;
 
%let StudyName=%nrbquote();
%let InData=%nrbquote($LS_HOME\Sample Data\Genetics\morocco_snps1exp_rg.sas7bdat);
%let AlleleVars= ;
%let TraitVars= ILMN_1722284;
%let SexVar= Sex;
%let ListMarkerVars=%nrbquote(rg_:);
%let ListTraitVars=%nrbquote();
%let WhereStmt=%nrbquote();
%let OutPath=%nrbquote($HOME/JMPG/ProcessResults/);
%let MacroPath= %nrbquote($GENOMICS_HOME\MacroLib);
%let QVars= ;
%let ListQVars=%nrbquote();
%let QSumto1= No;
%let TraitType=%nrbquote(Continuous);
%let ClassVars= ;
%let FixedEff=%nrbquote();
%let RandEff=%nrbquote();
%let RandOpts= ;
%let DDFM=%nrbquote(BETWITHIN);
%let UseLowerB= No;
%let GMethod= ;
%let MMethod=%nrbquote(REML);
%let AnnoInData=%nrbquote($LS_HOME\Sample Data\Genetics\morocco_anno_rg.sas7bdat);
%let AnnoLabel= gene_symbol;
%let AnnoMName= SNP_Name_RG;
%let AnnoGroup= chr;
%let AnnoLoc= coordinate;
%let AnnoAccession= accession;
%let AnnoWhereStmt=%nrbquote(chr = "01" or chr = "02" or chr = "03" or chr = "04");
%let XLVarStmt=%nrbquote(chr = "X");
%let AUnBiased= Yes;
%let OutAddMatrix= No;
%let OutRootAddMatrix= No;
%let Listing= No;
%let OutName=%nrbquote();
%let Server= Local;
%let GENOMICS_HOME=%nrbquote($GENOMICS_HOME\);
%let USER_HOME=%nrbquote($HOME\JMPG\);

*ProcessBody;

%include "$GENOMICS_HOME\ProcessLibrary\GenomicHeritability.sas"; 