/*
JMP Genomics Analytical Process

Name: ProgenySimulation
Author: Russ Wolfinger, SAS Institute Inc.
History:
   sasrdw 08Jan14 initial coding   
   sbrlsi 28Jan16 updating code to include topcross, backcross, map info, 
   		multiple generations, optimize cross, and error checking.

Description:
		Progeny Simulation simulates progeny from a set of crosses.
*/

/*
-----------------------------------------------------------
Copyright (C) 2014 SAS Institute, Inc. All rights reserved. 

Notice: 
The above copyright notice and this notice must appear in
any whole or partial copy of this code and any related
documentation. Permission to use, copy, and modify the
source code contained in this file is hereby granted, but
is limited to customers of SAS with a valid license for the
SAS software product with which this file was provided. 
Except as expressly set forth herein, the terms of such
license apply.
-----------------------------------------------------------
*/

*ProcessVariables;


%let StudyName=%nrbquote();
%let InData=%nrbquote($LS_HOME\Sample Data\Genetics\samplegmdata_numgeno.sas7bdat);
%let IDVars= Ped_id Ind_id;
%let SexVar= Sex;
%let TesterVar= ;
%let ParentalVar= ;
%let AlleleVars= ;
%let ListMarkerVars= %nrbquote(numgeno:);
%let WhereStmt=%nrbquote();
%let ScoringFolder=%nrbquote($LS_HOME\Sample Data\Genetics\);
%let ScoringFilter= ^*._score.sas;
%let ScoringCode= samplegmdata_numgeno_rr1_score.sas|samplegmdata_numgeno_rr2_score.sas;
%let OutPath=%nrbquote($HOME\JMPG\ProcessResults\);
%let MacroPath= $LS_HOME\MacroLib;
%let AnnoInData=%nrbquote($LS_HOME\Sample Data\Genetics\samplemap_pos.sas7bdat);
%let ChromNum= CandGene;
%let ChromLab= ;
%let MarkerLab= Marker_RG;
%let MarkerPos= cMcum_Haldane;
%let MarkerPos_BP= ;
%let CInData=%nrbquote();
%let MatingType= Include outcross only;
%let Maternal=%nrbquote();
%let P1Value= ;
%let P2Value= ;
%let SimMarkersInScore= Yes;
%let UseMapInfo= Yes;
%let MapFunc= Haldane;
%let NSim= 5;
%let Seed= 923748;
%let SimMultiGen= No;
%let NBack= ;
%let NSelf= ;
%let SimRil= No;
%let SimRilMethod= ;
%let OutData=%nrbquote();
%let Compress= Yes;
%let GenomicBLUPOutData= %nrbquote();
%let Server= Local;
%let LS_HOME=%nrbquote($LS_HOME\);
%let CLIENT_LS_HOME=%nrbquote($LS_HOME\);
%let GENOMICS_HOME=%nrbquote($GENOMICS_HOME);
%let USER_HOME=%nrbquote($HOME\);
%let LSUSER_HOME=%nrbquote($HOME\JMPLS\);
%let CLIENT_USER_HOME=%nrbquote($HOME\);
%let CLIENT_LSUSER_HOME=%nrbquote($HOME\JMPLS\);
%let Metapath=%nrbquote($HOME\);
%let Starter_Index=%nrbquote(2);
%let LS_Product=%nrbquote(Genomics);
%let CLIENT_HOST= Windows;


*ProcessBody;


%macro runAP;  
filename customap "$HOME\ProcessLibrary\ProgenySimulation.sas";
%if %sysfunc(fexist(customap)) %then %do;
   %include customap;
%end;
%else %do;
   %include "$GENOMICS_HOME\ProcessLibrary/ProgenySimulation.sas";
%end;
%mend;
%runAP;
